###################################################
### chunk number 1: 
###################################################
options(prompt = "R> ", continue="+ ", useFancyQuotes=FALSE)


###################################################
### chunk number 2: 
###################################################
data("npext", package="urca")   # load data
library("CADFtest")


###################################################
### chunk number 3: 
###################################################
ADFt <- CADFtest(npext$gnpperca, max.lag.y=3)


###################################################
### chunk number 4: 
###################################################
ADFt$p.value


###################################################
### chunk number 5: 
###################################################
CADFpvalues(ADFt$statistic, type="trend", rho2=1)


###################################################
### chunk number 6: 
###################################################
print(ADFt)


###################################################
### chunk number 7: 
###################################################
summary(ADFt)


###################################################
### chunk number 8: 
###################################################
res.ADFt <- residuals(ADFt)


###################################################
### chunk number 9: 
###################################################
plot(ADFt)


###################################################
### chunk number 10: 
###################################################
plot(ADFt)


###################################################
### chunk number 11: 
###################################################
plot(ADFt, plots=c(1,3,4))


###################################################
### chunk number 12: 
###################################################
plot(ADFt, plots=c(1,3,4))


###################################################
### chunk number 13: 
###################################################
npext$unemrate <- exp(npext$unemploy)      # compute unemployment rate
L <- ts(npext, start=1860)                 # time series of levels
D <- diff(L)                               # time series of diffs
S <- window(ts.intersect(L,D), start=1909) # select same sample as Hansen's


###################################################
### chunk number 14: 
###################################################
ADFt <- CADFtest(L.gnpperca ~ 1, data = S, max.lag.y = 3)


###################################################
### chunk number 15: 
###################################################
CADFtest(L.gnpperca ~ 1, data = S, max.lag.y = 4, criterion = "BIC", dname = "Extended Nelson-Plosser data")


###################################################
### chunk number 16: 
###################################################
ADFt2 <- update(ADFt, change=list("max.lag.y = 4", "criterion = 'BIC'", "dname = 'Extended Nelson-Plosser data'"))


###################################################
### chunk number 17: 
###################################################
ADFt <- CADFtest(L.gnpperca ~ 1, data = S, max.lag.y = 3)


###################################################
### chunk number 18: 
###################################################
CADFt <- update(ADFt, change=list("+ D.unemrate", "kernel = 'Parzen'", "prewhite = FALSE"))
print(CADFt)


###################################################
### chunk number 19: 
###################################################
CADFt <- update(CADFt, change=list("max.lag.X = 3", "min.lag.X = -3", "criterion = 'BIC'"))
print(CADFt)


###################################################
### chunk number 20: 
###################################################
CADFt <- CADFtest(L.gnpperca ~ D.unemrate, data = S, max.lag.y = 3, max.lag.X = 3, min.lag.X = -3, criterion = "BIC", kernel = "Parzen", prewhite = FALSE)


###################################################
### chunk number 21: 
###################################################
CADFt <- CADFtest(L.gnpperca ~ D.unemrate + D.indprod, data = S, max.lag.y = 3, max.lag.X = 3, min.lag.X = -3, criterion = "BIC", kernel = "Parzen", prewhite = FALSE)


###################################################
### chunk number 22: 
###################################################
CADFpvalues(t0 = -2.2, rho2 = 0.53)
CADFpvalues(t0 = -1.7, rho2 = 0.20)


###################################################
### chunk number 23: 
###################################################
CADFpvalues(-0.44, type = "drift", rho2 = 1)


###################################################
### chunk number 24: 
###################################################
library("urca")
adf.urca <- ur.df(npext$gnpperca[-(1:49)], type = "trend", lags = 3)


###################################################
### chunk number 25: 
###################################################
library("tseries")
adf.tseries <- adf.test(npext$gnpperca[-(1:49)], k = 3)


###################################################
### chunk number 26: 
###################################################
library("fUnitRoots")
adf.fUnitRoots <- unitrootTest(npext$gnpperca, lags = 3, type = "ct")


